package fr.irisa.cairn.jnimap.generator.java;

import fr.irisa.cairn.jniMap.EnumToClassMapping;
import fr.irisa.cairn.jniMap.EnumValue;
import fr.irisa.cairn.jniMap.Mapping;
import fr.irisa.cairn.jnimap.generator.CommonExtensions;
import fr.irisa.cairn.jnimap.generator.java.AbstractWrapper;
import fr.irisa.cairn.jnimap.generator.java.JNIJavaUtilities;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.Extension;

@SuppressWarnings("all")
public class EnumWrapperExtension extends AbstractWrapper {
  @Extension
  private CommonExtensions _commonExtensions = new CommonExtensions();
  
  @Extension
  private JNIJavaUtilities _jNIJavaUtilities = new JNIJavaUtilities();
  
  /**
   * There is no pointer management for Enum.
   * However, since the base constructor is defined here,
   * it is overridden to add some specific behaviors for Enum.
   */
  public CharSequence enumToClassMappingContent(final EnumToClassMapping cm, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = this._commonExtensions.packageName(m);
    _builder.append(_packageName);
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("import java.util.HashMap;");
    _builder.newLine();
    _builder.append("import java.util.Map;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("/*** PROTECTED REGION ID(");
    String _name = cm.getName();
    _builder.append(_name);
    _builder.append("_userImport) ENABLED START ***/");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("/*");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("Put you custom import here ....");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("*/");
    _builder.newLine();
    _builder.append("/*** PROTECTED REGION END ***/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*  Automatically generated by jnimap ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("public class ");
    CharSequence _javaClassName = this._jNIJavaUtilities.javaClassName(cm);
    _builder.append(_javaClassName);
    _builder.append("  {");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("int value;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("String name;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("/*** PROTECTED REGION ID(");
    String _name_1 = cm.getName();
    _builder.append(_name_1, "\t");
    _builder.append("_values) DISABLED START ***/");
    _builder.newLineIfNotEmpty();
    {
      EList<EnumValue> _values = cm.getEnum_().getValues();
      for(final EnumValue enumValue : _values) {
        {
          EnumValue _enumNext = enumValue.getEnumNext();
          boolean _tripleNotEquals = (_enumNext != null);
          if (_tripleNotEquals) {
            _builder.append("\t");
            _builder.append("public static final int ");
            String _upperCase = enumValue.getName().toUpperCase();
            _builder.append(_upperCase, "\t");
            _builder.append(" = ");
            String _upperCase_1 = enumValue.getEnumNext().getName().toUpperCase();
            _builder.append(_upperCase_1, "\t");
            _builder.append(";");
            _builder.newLineIfNotEmpty();
          } else {
            _builder.append("\t");
            _builder.append("public static final int ");
            String _upperCase_2 = enumValue.getName().toUpperCase();
            _builder.append(_upperCase_2, "\t");
            _builder.append(" = ");
            int _value = enumValue.getValue();
            _builder.append(_value, "\t");
            _builder.append(";");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    _builder.append("\t");
    _builder.append("/*** PROTECTED REGION END ***/");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    {
      EList<EnumValue> _values_1 = cm.getEnum_().getValues();
      for(final EnumValue enumValue_1 : _values_1) {
        _builder.append("\t");
        _builder.append("public static ");
        CharSequence _javaClassName_1 = this._jNIJavaUtilities.javaClassName(cm);
        _builder.append(_javaClassName_1, "\t");
        _builder.append(" ");
        String _name_2 = enumValue_1.getName();
        _builder.append(_name_2, "\t");
        _builder.append(" = new ");
        CharSequence _javaClassName_2 = this._jNIJavaUtilities.javaClassName(cm);
        _builder.append(_javaClassName_2, "\t");
        _builder.append("(\"");
        String _name_3 = enumValue_1.getName();
        _builder.append(_name_3, "\t");
        _builder.append("\", ");
        String _upperCase_3 = enumValue_1.getName().toUpperCase();
        _builder.append(_upperCase_3, "\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("public static ");
    CharSequence _javaClassName_3 = this._jNIJavaUtilities.javaClassName(cm);
    _builder.append(_javaClassName_3, "\t");
    _builder.append(" build(long value) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("return getFromInt((int) value) ;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("public static  ");
    CharSequence _javaClassName_4 = this._jNIJavaUtilities.javaClassName(cm);
    _builder.append(_javaClassName_4, "\t");
    _builder.append(" getFromInt(int value) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("/*** PROTECTED REGION ID(");
    String _name_4 = cm.getName();
    _builder.append(_name_4, "\t\t");
    _builder.append("_getValues) DISABLED START ***/");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("switch(value) {");
    _builder.newLine();
    {
      EList<EnumValue> _values_2 = cm.getEnum_().getValues();
      for(final EnumValue enumValue_2 : _values_2) {
        _builder.append("\t\t\t");
        _builder.append("case ");
        String _upperCase_4 = enumValue_2.getName().toUpperCase();
        _builder.append(_upperCase_4, "\t\t\t");
        _builder.append(":");
        _builder.newLineIfNotEmpty();
        {
          EnumValue _enumNext_1 = enumValue_2.getEnumNext();
          boolean _tripleEquals = (_enumNext_1 == null);
          if (_tripleEquals) {
            _builder.append("\t\t\t");
            _builder.append("return ");
            String _name_5 = enumValue_2.getName();
            _builder.append(_name_5, "\t\t\t");
            _builder.append(";");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    _builder.append("\t\t\t\t");
    _builder.append("default :");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("return null;");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("/*** PROTECTED REGION END ***/");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("private ");
    CharSequence _javaClassName_5 = this._jNIJavaUtilities.javaClassName(cm);
    _builder.append(_javaClassName_5, "\t");
    _builder.append("(String name, int value) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("this.value=value;");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("this.name=name;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("public int getValue() {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return this.value;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("public String getName() {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return this.name;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
}
